Bug 970285 - Review Request: shiro - A powerful and flexible open-source security framework
Review Request: shiro - A powerful and flexible open-source security framework
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jerry James
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 968136 998251 1193730
  Show dependency treegraph
 
Reported: 2013-06-03 17:30 EDT by gil cattaneo
Modified: 2015-10-24 23:44 EDT (History)
3 users (show)

See Also:
Fixed In Version: shiro-1.2.4-2.fc24
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-23 07:51:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
loganjerry: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2013-06-03 17:30:40 EDT
Spec URL: http://gil.fedorapeople.org/shiro.spec
SRPM URL: http://gil.fedorapeople.org/shiro-1.2.2-1.fc18.src.rpm
Description:
Apache Shiro is a powerful and flexible open-source security framework that
cleanly handles authentication, authorization, enterprise session management,
single sign-on and cryptography services.

Fedora Account System Username: gil

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=5463141
Comment 4 gil cattaneo 2015-01-28 19:17:29 EST
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=8758088
Comment 6 Jerry James 2015-10-22 11:33:32 EDT
I will take this review.
Comment 7 Jerry James 2015-10-22 13:43:42 EDT
Package Review
==============

Issues:
1. Most of the sources are covered under ASL 2.0, but note that
   core/src/main/java/org/apache/shiro/codec/H64.java says that the
   apr_md5_encode() routine uses FreeBSD crypt() code, which is covered by the
   Beerware license (https://fedoraproject.org/wiki/Licensing/Beerware).
   Should the license be "ASL 2.0 and Beerware"?

2. The top-level NOTICE file says:

Certain parts (StringUtils etc.) of the source code for this
product was copied for simplicity and to reduce dependencies
from the source code developed by the Spring Framework Project
(http://www.springframework.org).

   Do you know the extent to which such copying was done?  Does this package
   need to unbundle some code, or add a bundled(foo) tag?  (Fortunately, Spring
   Framework is also ASL 2.0, so there are no license issues.)

3. This is a SHOULD, not a MUST, but some files could keep their timestamps
   that currently don't.  For example, this line in %install:

sed 's/\r//' -i LICENSE RELEASE-NOTES

   could be done like this instead to preserve timestamps:

for fil in LICENSE RELEASE-NOTES; do
  sed 's/\r//' -i.orig $fil
  touch -r $fil.orig $fil
  rm -f $fil.orig
done

4. Speaking of that, README also has the wrong end-of-line encoding.


Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "*No copyright* Beerware Apache (v2.0)",
     "Unknown or generated", "*No copyright* Apache (v2.0)". 1 files have
     unknown license.
[x]: License file installed when any subpackage combination is installed.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in shiro-
     core , shiro-cas , shiro-ehcache , shiro-guice , shiro-quartz , shiro-
     spring , shiro-web , shiro-samples , shiro-tools , shiro-javadoc

     This is okay because maven dependencies are generated appropriately.

[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.

     There is no %check, but maven runs tests as part of the build.

[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: shiro-1.2.4-1.fc24.noarch.rpm
          shiro-core-1.2.4-1.fc24.noarch.rpm
          shiro-cas-1.2.4-1.fc24.noarch.rpm
          shiro-ehcache-1.2.4-1.fc24.noarch.rpm
          shiro-guice-1.2.4-1.fc24.noarch.rpm
          shiro-quartz-1.2.4-1.fc24.noarch.rpm
          shiro-spring-1.2.4-1.fc24.noarch.rpm
          shiro-web-1.2.4-1.fc24.noarch.rpm
          shiro-samples-1.2.4-1.fc24.noarch.rpm
          shiro-tools-1.2.4-1.fc24.noarch.rpm
          shiro-javadoc-1.2.4-1.fc24.noarch.rpm
          shiro-1.2.4-1.fc24.src.rpm
shiro.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/shiro/README
shiro-core.noarch: W: no-documentation
shiro-cas.noarch: W: no-documentation
shiro-ehcache.noarch: W: no-documentation
shiro-guice.noarch: W: no-documentation
shiro-quartz.noarch: W: no-documentation
shiro-spring.noarch: W: no-documentation
shiro-web.noarch: W: no-documentation
shiro-samples.noarch: W: no-documentation
shiro-tools.noarch: W: no-documentation
12 packages and 0 specfiles checked; 0 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
shiro-samples.noarch: W: no-documentation
shiro-guice.noarch: W: no-documentation
shiro-tools.noarch: W: no-documentation
shiro-ehcache.noarch: W: no-documentation
shiro-core.noarch: W: no-documentation
shiro-quartz.noarch: W: no-documentation
shiro-web.noarch: W: no-documentation
shiro-cas.noarch: W: no-documentation
shiro-spring.noarch: W: no-documentation
shiro.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/shiro/README
11 packages and 0 specfiles checked; 0 errors, 10 warnings.



Requires
--------
shiro-samples (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.shiro:shiro-core)

shiro-guice (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(com.google.inject.extensions:guice-multibindings)
    mvn(com.google.inject:guice)
    mvn(org.apache.shiro:shiro-core)

shiro-tools (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(commons-cli:commons-cli)
    mvn(org.apache.shiro:shiro-core)
    mvn(org.slf4j:slf4j-simple)

shiro-ehcache (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(net.sf.ehcache:ehcache-core)
    mvn(org.apache.shiro:shiro-core)

shiro-core (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(commons-beanutils:commons-beanutils)
    mvn(org.slf4j:slf4j-api)

shiro-quartz (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.shiro:shiro-core)
    mvn(org.quartz-scheduler.internal:quartz-core)

shiro-web (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.shiro:shiro-core)

shiro-cas (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.shiro:shiro-web)
    mvn(org.jasig.cas.client:cas-client-core)

shiro-spring (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.shiro:shiro-core)
    mvn(org.apache.shiro:shiro-web)

shiro-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

shiro (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.maven.plugins:maven-compiler-plugin)
    mvn(org.apache.maven.plugins:maven-jar-plugin)
    mvn(org.apache.maven.plugins:maven-release-plugin)
    mvn(org.apache.maven.plugins:maven-surefire-plugin)
    mvn(org.apache.rat:apache-rat-plugin)
    mvn(org.apache:apache:pom:)
    mvn(org.codehaus.mojo:buildnumber-maven-plugin)



Provides
--------
shiro-samples:
    mvn(org.apache.shiro.samples:samples-quickstart)
    mvn(org.apache.shiro.samples:samples-quickstart:pom:)
    mvn(org.apache.shiro.samples:shiro-samples:pom:)
    shiro-samples

shiro-guice:
    mvn(org.apache.shiro:shiro-guice)
    mvn(org.apache.shiro:shiro-guice:pom:)
    osgi(org.apache.shiro.guice)
    shiro-guice

shiro-tools:
    mvn(org.apache.shiro.tools:shiro-tools-hasher)
    mvn(org.apache.shiro.tools:shiro-tools-hasher:pom:)
    mvn(org.apache.shiro.tools:shiro-tools:pom:)
    osgi(org.apache.shiro.tools.hasher)
    shiro-tools

shiro-ehcache:
    mvn(org.apache.shiro:shiro-ehcache)
    mvn(org.apache.shiro:shiro-ehcache:pom:)
    osgi(org.apache.shiro.ehcache)
    shiro-ehcache

shiro-core:
    mvn(org.apache.shiro:shiro-core)
    mvn(org.apache.shiro:shiro-core::tests:)
    mvn(org.apache.shiro:shiro-core:pom:)
    osgi(org.apache.shiro.core)
    shiro-core

shiro-quartz:
    mvn(org.apache.shiro:shiro-quartz)
    mvn(org.apache.shiro:shiro-quartz:pom:)
    osgi(org.apache.shiro.quartz)
    shiro-quartz

shiro-web:
    mvn(org.apache.shiro:shiro-web)
    mvn(org.apache.shiro:shiro-web:pom:)
    osgi(org.apache.shiro.web)
    shiro-web

shiro-cas:
    mvn(org.apache.shiro:shiro-cas)
    mvn(org.apache.shiro:shiro-cas:pom:)
    osgi(org.apache.shiro.cas)
    shiro-cas

shiro-spring:
    mvn(org.apache.shiro:shiro-spring)
    mvn(org.apache.shiro:shiro-spring:pom:)
    osgi(org.apache.shiro.spring)
    shiro-spring

shiro-javadoc:
    shiro-javadoc

shiro:
    mvn(org.apache.shiro:shiro-root:pom:)
    mvn(org.apache.shiro:shiro-support:pom:)
    shiro



Source checksums
----------------
http://www.apache.org/dist/shiro/1.2.4/shiro-root-1.2.4-source-release.zip :
  CHECKSUM(SHA256) this package     : c972bbf6727f6c838fd896e0f760381af98a568995d627afb3f9f6ac5d1a050e
  CHECKSUM(SHA256) upstream package : c972bbf6727f6c838fd896e0f760381af98a568995d627afb3f9f6ac5d1a050e


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 970285 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 8 Upstream Release Monitoring 2015-10-22 23:07:19 EDT
gil's scratch build of shiro-1.2.4-2.fc22.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11550399
Comment 9 gil cattaneo 2015-10-22 23:10:48 EDT
(In reply to Jerry James from comment #7)
> Package Review
> ==============
> 
> Issues:
> 1. Most of the sources are covered under ASL 2.0, but note that
>    core/src/main/java/org/apache/shiro/codec/H64.java says that the
>    apr_md5_encode() routine uses FreeBSD crypt() code, which is covered by
> the
>    Beerware license (https://fedoraproject.org/wiki/Licensing/Beerware).
>    Should the license be "ASL 2.0 and Beerware"?

Done

> 2. The top-level NOTICE file says:
> 
> Certain parts (StringUtils etc.) of the source code for this
> product was copied for simplicity and to reduce dependencies
> from the source code developed by the Spring Framework Project
> (http://www.springframework.org).
> 
>    Do you know the extent to which such copying was done?

Unfortunately these are older versions of SF, the code in question has also undergone changes that make it impractical to use the original classes

>   Does this package need to unbundle some code, or add a bundled(foo) tag?

Done

> 3. This is a SHOULD, not a MUST, but some files could keep their timestamps
>    that currently don't.  For example, this line in %install:
> 
> sed 's/\r//' -i LICENSE RELEASE-NOTES
> 
>    could be done like this instead to preserve timestamps:
> 
> for fil in LICENSE RELEASE-NOTES; do
>   sed 's/\r//' -i.orig $fil
>   touch -r $fil.orig $fil
>   rm -f $fil.orig
> done

Fixed

> 4. Speaking of that, README also has the wrong end-of-line encoding.
Done

Spec URL: http://gil.fedorapeople.org/shiro.spec
SRPM URL: http://gil.fedorapeople.org/shiro-1.2.4-2.fc22.src.rpm
Comment 10 Jerry James 2015-10-22 23:31:04 EDT
(In reply to gil cattaneo from comment #9)
> Unfortunately these are older versions of SF, the code in question has also
> undergone changes that make it impractical to use the original classes

Okay, the comments in the code suggested that.  Just wanted to be sure.

All other issues have been resolved, so this package is APPROVED.
Comment 11 gil cattaneo 2015-10-22 23:57:15 EDT
(In reply to Jerry James from comment #10)
> (In reply to gil cattaneo from comment #9)
> > Unfortunately these are older versions of SF, the code in question has also
> > undergone changes that make it impractical to use the original classes
> 
> Okay, the comments in the code suggested that.  Just wanted to be sure.
> 
> All other issues have been resolved, so this package is APPROVED.

Thanks!
Done some changes in the spec files:
 - Separate all artifacts in their sub packages

i have a doubt about how declare bundled(foo)
I have not found documentation about this (have a link?)
 foo is the name of the sub nodule?
 e.g.
   org.springframework:spring-context
   Provides:      bundled(spring-context)
 or the name of rpm? then become
   Provides:      bundled(springframework-context)
Comment 12 gil cattaneo 2015-10-23 01:45:58 EDT
Spec URL: http://gil.fedorapeople.org/shiro.spec
SRPM URL: http://gil.fedorapeople.org/shiro-1.2.4-2.fc22.src.rpm

- add shiro-tools-hasher script and man1page
Comment 13 gil cattaneo 2015-10-23 02:18:24 EDT
Request for new package https://admin.fedoraproject.org/pkgdb/package/requests/1109
Comment 14 gil cattaneo 2015-10-23 07:51:10 EDT
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11556810
Comment 15 Jerry James 2015-10-24 23:44:48 EDT
(In reply to gil cattaneo from comment #11)
> i have a doubt about how declare bundled(foo)
> I have not found documentation about this (have a link?)
>  foo is the name of the sub nodule?
>  e.g.
>    org.springframework:spring-context
>    Provides:      bundled(spring-context)
>  or the name of rpm? then become
>    Provides:      bundled(springframework-context)

Hmmm, I don't think I know the answer to that myself.  Maybe it doesn't matter.  The intent is simply to identify the thing that is bundled, in which case either form is okay.  Personally, I think I prefer the second form.

Note You need to log in before you can comment on or make changes to this bug.